osgParticle::AngularDampingOperator Class Reference

`#include <AngularDampingOperator>`

Inheritance diagram for osgParticle::AngularDampingOperator:

## Public Member Functions

| AngularDampingOperator ()
| AngularDampingOperator (const AngularDampingOperator &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgParticle, AngularDampingOperator)
void | setDamping (float x, float y, float z)
| Set the damping factors.
void | setDamping (const osg::Vec3 &damping)
void | setDamping (float x)
| Set the damping factors to one value.
void | getDamping (float &x, float &y, float &z) const
| Get the damping factors.
const osg::Vec3 & | getDamping () const
void | setCutoff (float low, float high)
| Set the velocity cutoff factors.
void | setCutoffLow (float low)
void | setCutoffHigh (float low)
void | getCutoff (float &low, float &high) const
| Get the velocity cutoff factors.
float | getCutoffLow () const
float | getCutoffHigh () const
void | operate (Particle *P, double dt)
| Apply the acceleration to a particle. Do not call this method manually.
Public Member Functions inherited from osgParticle::Operator
| Operator ()
| Operator (const Operator &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual const char * | libraryName () const
virtual const char * | className () const
virtual bool | isSameKindAs (const osg::Object *obj) const
bool | isEnabled () const
| Get whether this operator is enabled.
void | setEnabled (bool v)
| Enable or disable this operator.
virtual void | operateParticles (ParticleSystem *ps, double dt)
virtual void | beginOperate (Program *)
virtual void | endOperate ()
| Do something after all particles have been processed.
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~AngularDampingOperator ()
AngularDampingOperator & | operator= (const AngularDampingOperator &)
Protected Member Functions inherited from osgParticle::Operator
virtual | ~Operator ()
Operator & | operator= (const Operator &)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::Vec3 | _damping
float | _cutoffLow
float | _cutoffHigh
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

A angular damping operator applies damping constant to particle's angular velocity. Refer to David McAllister's Particle System API (http://www.particlesystems.org)

## Constructor & Destructor Documentation

## AngularDampingOperator() [1/2]

osgParticle::AngularDampingOperator::AngularDampingOperator | ( |  | ) |

inline

References _cutoffHigh, _cutoffLow, and osgParticle::Operator::Operator().

Referenced by AngularDampingOperator(), META_Object(), and operator=().

## AngularDampingOperator() [2/2]

osgParticle::AngularDampingOperator::AngularDampingOperator | ( | const AngularDampingOperator & | copy,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

inline

References _cutoffHigh, _cutoffLow, _damping, AngularDampingOperator(), osgParticle::Operator::Operator(), and osg::CopyOp::SHALLOW_COPY.

## ~AngularDampingOperator()

virtual osgParticle::AngularDampingOperator::~AngularDampingOperator | ( |  | ) |

inline protected virtual

## Member Function Documentation

## getCutoff()

void osgParticle::AngularDampingOperator::getCutoff | ( | float & | low,
|  | float & | high ) const

inline

Get the velocity cutoff factors.

References _cutoffHigh, and _cutoffLow.

## getCutoffHigh()

float osgParticle::AngularDampingOperator::getCutoffHigh | ( |  | ) | const

inline

References _cutoffHigh.

## getCutoffLow()

float osgParticle::AngularDampingOperator::getCutoffLow | ( |  | ) | const

inline

References _cutoffLow.

## getDamping() [1/2]

const osg::Vec3 & osgParticle::AngularDampingOperator::getDamping | ( |  | ) | const

inline

References _damping.

## getDamping() [2/2]

void osgParticle::AngularDampingOperator::getDamping | ( | float & | x,
|  | float & | y,
|  | float & | z ) const

inline

Get the damping factors.

References _damping.

## META_Object()

osgParticle::AngularDampingOperator::META_Object | ( | osgParticle | ,
|  | AngularDampingOperator | )

References AngularDampingOperator().

## operate()

void osgParticle::AngularDampingOperator::operate | ( | Particle * | P,
|  | double | dt )

inline virtual

Apply the acceleration to a particle. Do not call this method manually.

Implements osgParticle::Operator.

References _cutoffHigh, _cutoffLow, _damping, osgParticle::Particle::getAngularVelocity(), osg::Vec3f::length2(), osgParticle::Particle::setAngularVelocity(), osg::Vec3f::x(), osg::Vec3f::y(), and osg::Vec3f::z().

## operator=()

AngularDampingOperator & osgParticle::AngularDampingOperator::operator= | ( | const AngularDampingOperator & |  | ) |

inline protected

References AngularDampingOperator().

## setCutoff()

void osgParticle::AngularDampingOperator::setCutoff | ( | float | low,
|  | float | high )

inline

Set the velocity cutoff factors.

References _cutoffHigh, and _cutoffLow.

## setCutoffHigh()

void osgParticle::AngularDampingOperator::setCutoffHigh | ( | float | low | ) |

inline

References _cutoffHigh.

## setCutoffLow()

void osgParticle::AngularDampingOperator::setCutoffLow | ( | float | low | ) |

inline

References _cutoffLow.

## setDamping() [1/3]

void osgParticle::AngularDampingOperator::setDamping | ( | const osg::Vec3 & | damping | ) |

inline

References _damping.

## setDamping() [2/3]

void osgParticle::AngularDampingOperator::setDamping | ( | float | x | ) |

inline

Set the damping factors to one value.

References _damping.

## setDamping() [3/3]

void osgParticle::AngularDampingOperator::setDamping | ( | float | x,
|  | float | y,
|  | float | z )

inline

Set the damping factors.

References _damping.

## Member Data Documentation

## _cutoffHigh

float osgParticle::AngularDampingOperator::_cutoffHigh

protected

Referenced by AngularDampingOperator(), AngularDampingOperator(), getCutoff(), getCutoffHigh(), operate(), setCutoff(), and setCutoffHigh().

## _cutoffLow

float osgParticle::AngularDampingOperator::_cutoffLow

protected

Referenced by AngularDampingOperator(), AngularDampingOperator(), getCutoff(), getCutoffLow(), operate(), setCutoff(), and setCutoffLow().

## _damping

osg::Vec3 osgParticle::AngularDampingOperator::_damping

protected

Referenced by AngularDampingOperator(), getDamping(), getDamping(), operate(), setDamping(), setDamping(), and setDamping().

The documentation for this class was generated from the following file:

- AngularDampingOperator